#ifndef SIZEDEFS_INCLUDE
#define SIZEDEFS_INCLUDE
/*
 * Size and type definitions for screen.
 *
 * If this file is modified, COPPER.c, DOUBLE.c, SPACEWAR.c & GAMELOGIC.c
 * will be recompiled.
 */
 
/* DEPTH is the number of bitplane for your display.
   1 = 2  colors
   2 = 4  colors
   3 = 8  colors
   4 = 16 colors
   5 = 32 colors
   6 = 64 colors [Extra-HalfBrite] or
       4096 colors [Hold-And-Modify]
*/
#define DEPTH	2

/* WIDTH is the width of the display in pixels.  If you set it to more than
   320 you must set the HIRES bit of the MODES define. */
#define WIDTH	640

/* HEIGHT is the height of the display in pixels.  If you set to to more than
   200 you must set the LACE bit of the MODES define. */
#define HEIGHT	200

/* MODES is used to define the display modes you want.  Valid flags are
     HIRES -> 640 across
     LACE  -> 400 down
     HAM   -> Hold-And-Modify
     EXTRA_HALFBRITE -> Extra-HalfBrite mode.
*/
#define MODES	HIRES

/* NOTE: If you want to use Dual Playfield mode or you want an Overscan
   display I'll have to make some changes to the rest of the program. */

#endif
